<div class="container-fluid py-3">
  <h2>Validación de Formularios en Angular (avanzado)</h2>

  <div class="row justify-content-center my-5">
    <div class="col-4">
      <form [formGroup]="reactiveForm" #form="ngForm">
        <div class="row">
          <div class="col mb-2">
            <label for="name" class="form-label">Nombre:</label>
            <input type="text" id="name" name="name" formControlName="name" placeholder="Su nombre" required minlength="1" maxlength="250" class="form-control form-control-sm" [class.is-invalid]="name.invalid && (name.dirty || name.touched)">
            <div *ngIf="name.invalid && (name.dirty || name.touched)" class="invalid-feedback">
              <div *ngIf="name.errors?.['required']">
                Este campo es obligatorio.
              </div>
              <div *ngIf="name.errors?.['minlength']">
                Este campo debe tener al menos un caracter.
              </div>
              <div *ngIf="name.errors?.['maxlength']">
                Este campo no debe exceder de los 250 caracteres.
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col mb-2">
            <label for="nickname" class="form-label">Nickname:</label>
            <input type="text" id="nickname" name="nickname" formControlName="nickname" placeholder="Su nickname" maxlength="10" class="form-control form-control-sm" [class.is-invalid]="nickname.invalid && (nickname.dirty || nickname.touched)">
            <div *ngIf="nickname.invalid && (nickname.dirty || nickname.touched)" class="invalid-feedback">
              <div *ngIf="nickname.errors?.['maxlength']">
                Este campo debe tener por lo menos 10 caracteres.
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col mb-2">
            <label for="email" class="form-label">Correo E.:</label>
            <input type="email" id="email" name="email" formControlName="email" placeholder="su-nombre@proveedor.com" required minlength="1" maxlength="250" class="form-control form-control-sm" [class.is-invalid]="email.invalid && (email.dirty || email.touched)">
            <div *ngIf="email.invalid && (email.dirty || email.touched)" class="invalid-feedback">
              <div *ngIf="email.errors?.['required']">
                Este campo es obligatorio.
              </div>
              <div *ngIf="email.errors?.['minlength']">
                Este campo debe tener al menos un caracter.
              </div>
              <div *ngIf="email.errors?.['maxlength']">
                Este campo no debe exceder de los 250 caracteres.
              </div>
              <div *ngIf="!email.errors?.['required'] && !email.errors?.['minlength'] && !email.errors?.['maxlength'] && email.errors?.['emailValidator']">
                Formato de correo e. no válido.
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col mb-2">
            <label for="password" class="form-label">Contraseña:</label>
            <div class="input-group input-group-sm has-validation">
              <input [type]="user!.showPassword ? 'text' : 'password'" id="password" name="password" formControlName="password" required minlength="15" class="form-control form-control-sm" [class.is-invalid]="password.invalid && (password.dirty || password.touched)">
              <button type="button" class="btn btn-outline-secondary" (click)="user!.showPassword = !user!.showPassword">
                <i class="bi" [ngClass]="{'bi-eye-fill': !user!.showPassword, 'bi-eye-slash-fill': user!.showPassword}"></i>
              </button>
              <div *ngIf="password.invalid && (password.dirty || password.touched)" class="invalid-feedback">
                <div *ngIf="password.errors?.['required']">
                  Este campo es obligatorio.
                </div>
                <div *ngIf="password.errors?.['minlength']">
                  Este campo debe tener por lo menos 15 caracteres.
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col mb-2 d-grid">
            <button type="button" class="btn btn-sm btn-primary" (click)="validate()">Validar</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>
